# Script to start a batch decoding job
__author__ = "Beerend Ceulemans"
__email__ = "bceulema@etro.vub.ac.be"
import os
import threading

DECODER_EXE = 'TAppDecoder13-3D.exe'

sequences = ['Linear2','Arc1']
QPs = [30,35,37,40,44,47,50]

jobs = []

def worker(mutex):
    while True:
        mutex.acquire(1)
        if len(jobs) == 0:
            print 'Worker finished.'
            mutex.release()
            break
        (name,QP) = jobs.pop()
        mutex.release()
        file_in    = name + '-compressed\\stream_QP' + str(QP) + '.bit'
        folder_out = name + '-decoded\\QP' + str(QP)
        if not(os.path.exists(folder_out)):
            os.makedirs(folder_out)
        file_out   = folder_out + '\\dec.yuv'
        file_log   = folder_out + '\\dec.log'
	args       = '-b ' + file_in + ' -o ' + file_out + ' >> ' + file_log
        os.system(DECODER_EXE + ' ' + args)       
    return 0

for name in sequences:
    for QP in QPs:
        jobs.append( (name,QP) )

mutex = threading.Lock()
# The script is written to run in multiple threads, but I found that
# a single thread has a lot of disk usage so just running everything separately
# should be faster
max_num_threads = 1
threads = []
for i in range(max_num_threads):
    t = threading.Thread(target=worker,args=(mutex,))
    threads.append(t)
    t.start()
	
mutex.acquire(1)    
print 'Threads are running...'
mutex.release()

for t in threads:
    t.join()