import os
import VSRS_Arc1 as vsrs
cameras = vsrs.readCameras()
orig_cams  = cameras[0:7] # not using cam_8
synth_cams = cameras[8:len(cameras)]
cameras.sort(key=lambda c:c[1]) # sort cameras in ascending x-coordinate

QPs = [0,30,35,37,40,44,47,50]
NpixelsPerFrame  = vsrs.VIDEO_W * vsrs.VIDEO_H + (vsrs.VIDEO_W * vsrs.VIDEO_H) / 2
NbytesPerElement = 1
NrOfFrames       = 250

def nextCam(camIdx,direction):
    camIdx += direction
    if camIdx == len(cameras)-1:
        direction = -1
    if camIdx == 0:
        direction = +1
    return camIdx,direction

for QP in QPs: # for each QP, make a sweep video
    name = 'new_sweep_4_1_QP' + str(QP)
    f_out = open(vsrs.video_folder(QP) + "\\" + name + '.yuv', "wb")
    f_log = open(vsrs.video_folder(QP) + "\\" + name + '.txt', "w")
    camIdx = 0
    direction = +1
    frameNr = 0
    while frameNr < NrOfFrames:
        currCam = cameras[camIdx]
        f_log.write('#' + str(frameNr) + ' ' + str(currCam) + '\n')
        if currCam in orig_cams:
            print 'Copying frameNr ' + str(frameNr) + ' from cam ' + str(camIdx)
            # copy from original stream
            color = vsrs.colorFileName(currCam,QP)            
            f_tmp = open(color,'rb')
            # go to the requested frame
            f_tmp.seek((frameNr)*NpixelsPerFrame*NbytesPerElement)
            # read and write frame
            f_out.write(f_tmp.read(NpixelsPerFrame*NbytesPerElement))
            f_tmp.close()
        else:
            # first find the left and right orig cams
            left_cam,right_cam = vsrs.findLeftRight(currCam,orig_cams)
            if left_cam == None or right_cam == None: # cannot use this camera, go to next
                camIdx,direction = nextCam(camIdx,direction)
                continue
            # synthesize view
            print currCam
            print 'Synthesizing frameNr ' + str(frameNr) + ' for cam ' + str(camIdx) + ' from ' + left_cam[0] + ' and ' + right_cam[0]
            print 'Checking ' + vsrs.virtualFileName(left_cam,currCam,right_cam,QP)
            if os.path.isfile(vsrs.virtualFileName(left_cam,currCam,right_cam,QP)):
                print 'Can copy.'
                f_tmp = open(vsrs.virtualFileName(left_cam,currCam,right_cam,QP),'rb')
                # go to the requested frame
                f_tmp.seek((frameNr)*NpixelsPerFrame*NbytesPerElement)
                # read and write frame
                f_out.write(f_tmp.read(NpixelsPerFrame*NbytesPerElement))
                f_tmp.close()                
            else:
                config = 'sweep_config_QP' + str(QP) + '.cfg'
                output = vsrs.make_config(config,left_cam,currCam,right_cam,QP,start=frameNr,nrOfFrames=1,temp=True)
                os.system(vsrs.VSRS_PATH + ' ' + config)
                # append the content from the temp file to the output sweep video
                f_tmp = open(output,"rb")
                f_out.write(f_tmp.read())
                f_tmp.close()
        # go to the next camera
        camIdx,direction = nextCam(camIdx,direction)
        frameNr += 1
    f_out.close()
    f_log.close()