import os
import VSRS_Arc1 as vsrs
import threading
import time

numFrames = 250

cameras = vsrs.readCameras()
orig_cams  = cameras[0:7]
synth_cams = cameras[8:len(cameras)]

jobs = []

def worker(mutex):
    while True:
        mutex.acquire(1)
        if len(jobs) == 0:
            print 'Worker finished.'
            mutex.release()
            break
        (virtual_view,QP) = jobs.pop()
        mutex.release()
        # first find the left and right orig cams
        left_cam,right_cam = vsrs.findLeftRight(virtual_view,orig_cams)
        if left_cam == None or right_cam == None:
            #mutex.acquire(1)
            #print "Can't find left-right pair for " + virtual_view[0]
            #mutex.release()   
            continue
        
        config_name = 'cfg\\Arc1_config_QP' + str(QP) + '_' + virtual_view[0] + '.cfg'        
        output = vsrs.make_config(config_name,left_cam,virtual_view,right_cam,QP,start=0,nrOfFrames=numFrames,blend=0,precision=4,DepthType=1)
        if os.path.isfile(output):
            os.remove(config_name)
            continue        
        mutex.acquire(1)
        print time.strftime("%H:%M:%S") + " Thread: %d %s from %s and %s" % (QP,virtual_view[0],left_cam[0],right_cam[0])
        mutex.release()   
        logfile = output.replace('.yuv','.txt')
        os.system(vsrs.VSRS_PATH + ' ' + config_name + ' >' + logfile)
        os.remove(config_name)        
    return 0

# cleaning up directory
#for QP in QPs:
    #os.system('del ' + vsrs.virtual_video_folder(QP) + '\\virtual_*.*' )

if not(os.path.exists('cfg')):
    os.makedirs('cfg')

mutex = threading.Lock()
QPs = [0,30,35,37,40,44,47,50]
for QP in QPs:
    if not os.path.exists(vsrs.virtual_video_folder(QP)):
        os.makedirs(vsrs.virtual_video_folder(QP))

for virtual_view in orig_cams[1:len(orig_cams)-1] + synth_cams:
    for QP in QPs:
        jobs.append( (virtual_view, QP) )

max_num_threads = 10
threads = []
for i in range(max_num_threads):
    t = threading.Thread(target=worker,args=(mutex,))
    threads.append(t)
    t.start()
      
mutex.acquire(1)    
print 'Threads are running...'
mutex.release()  

for t in threads:
    t.join()